<?php

namespace OCA\OwnershipTransfer\Settings;

use OCA\OwnershipTransfer\AppInfo\Application;
use OCP\App\IAppManager;
use OCP\AppFramework\Http\TemplateResponse;
use OCP\AppFramework\Services\IInitialState;
use OCP\IUser;
use OCP\IUserManager;

use OCP\Settings\ISettings;

class Admin implements ISettings {

	public function __construct(
		private string $userId,
		private IUserManager $userManager,
		private IAppManager $appManager,
		private IInitialState $initialState,
	) {
	}

	/**
	 * @return TemplateResponse
	 */
	public function getForm(): TemplateResponse {
		/** @var IUser */
		$user = $this->userManager->get($this->userId);

		$enabledApps = $this->appManager->getEnabledAppsForUser($user);
		$this->initialState->provideInitialState('enabledApps', $enabledApps);

		return new TemplateResponse(Application::APP_ID, 'adminSettings');
	}

	public function getSection(): string {
		return Application::APP_ID;
	}

	public function getPriority(): int {
		return 10;
	}
}
